// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_FComponentKey
	{
	public:
		virtual ~ISCW_FComponentKey() = default;
		
		virtual shared_ptr<ISCW_FComponentKey> ToFComponentKeyPtr() = 0;
		virtual shared_ptr<const ISCW_FComponentKey> ToFComponentKeyPtr() const = 0;

		virtual bool IsValid() const = 0;
	};

	using ISCW_FComponentKeyConstPtr = shared_ptr<const ISCW_FComponentKey>;
	using ISCW_FComponentKeyPtr = shared_ptr<ISCW_FComponentKey>;
} // namespace Sourcify